#! /usr/bin/python

# To change this template, choose Tools | Templates
# and open the template in the editor.

__author__="bjschuma"
__date__ ="$Apr 20, 2010 10:07:25 PM$"

import gtk
import guibuilder
import ocarina
import gstreamer

class VolumeControl(gtk.VolumeButton):
	def __init__(self,attrs):
		gtk.VolumeButton.__init__(self)
		relief = gtk.RELIEF_NORMAL
		for a in attrs:
			if a=="relief":
				if attrs[a] == "none":
					relief = gtk.RELIEF_NONE
				elif attrs[a] == "half":
					relief = gtk.RELIEF_HALF
		self.set_relief(relief)

		adj = self.get_adjustment()
		adj.set_page_increment(ocarina.vars.VOLUMEINCR)
		self.setValue()
		self.connect("value-changed",self.valueChanged)
		self.show()


	def setValue(self):
		self.set_value(ocarina.vars.VOLUME)

	def valueChanged(self, widget, value):
		gstreamer.setvol(value)


def make_volume(attrs):return VolumeControl(attrs)
guibuilder.parts["volume"] = make_volume
