
__author__="bjschuma"
__date__ ="$May 11, 2010 10:31:27 PM$"


__all__ = ["playback", "position", "volume"]


import gst

from ocarina import vars
from ocarina import events
from ct import path
from ct import call

global player
global time

player = gst.element_factory_make("playbin2", "player")
time = gst.Format(gst.FORMAT_TIME)



def load(song):
	song = path.expand(song)
	if path.exists(song) == False:
		call.write("Path does not exist: " + song)
		return

	playing = call.playing(False)
	if playing == True:
		call.pause()

	call.write("Loading file: " + song, 1)

	global player
	player.set_state(gst.STATE_NULL)
	player.set_property("uri", "file://" + song)

	if (vars.PLAYONLOAD == True) or (playing==True):
		call.play()


def init():
	from gstreamer import playback
	from gstreamer import volume
	from gstreamer import position


init()