#! /usr/bin/python

__author__ = "bjschuma"
__date__ = "$Feb 5, 2010 7:53:19 PM$"



def uninit():
	global player
	player.set_state(gst.STATE_NULL)



def onMessage(bus, message):
	#print message.type
	if message.type == gst.MESSAGE_TAG:
		taglist = message.parse_tag()
		for tag in taglist.keys():
			write("Found tag: ("+tag+", "+str(taglist[tag])+")",1)
			if tag == "title":
				ocarina.vars.TITLE = taglist[tag]
			elif tag == "artist":
				ocarina.vars.ARTIST = taglist[tag]
			elif tag == "album":
				ocarina.vars.ALBUM = taglist[tag]
		ocarina.events.start("tags-changed")


bus.add_signal_watch()
bus.connect("message", onMessage)
events.invite(events.OCARINA_QUIT, uninit)

