#! /usr/bin/python

# To change this template, choose Tools | Templates
# and open the template in the editor.

__author__="bjschuma"
__date__ ="$Jan 4, 2010 3:27:05 PM$"


import xml
import xml.dom.minidom as xml
from ct.path import *


def new():
	return xml.Document()


def element(document,name):
	return document.createElement(name)


def text(document,name):
	return document.createTextNode( str(name) )


def append(document,child):#,root=None):
	document.appendChild(child)
	

def child(document):#root=None):
	return document.firstChild


def children(document):
	if document.hasChildNodes() == False:
		return []
	return document.childNodes


def attributes(document):
	attrs = dict()
	if document.hasAttributes() == True:
		for i in range(document.attributes.length):
			item = document.attributes.item(i)
			attrs[item.name] = item.nodeValue
	return attrs


def write(document,path):
	out = open(path,'w')
	out.write(document.toprettyxml(indent=" "))
	out.close()


def load(path):
	fin = open(path)
	if fin == None:
		return
	document = xml.parse(fin)
	return document


def isElm(node):
	return node.nodeType == 1


def isText(node):
	return node.nodeType == 3


def name(node):
	return node.nodeName


def value(node):
	val = node.nodeValue.strip()
	if val == "False":
		return False
	elif val == "True":
		return True
	elif val.isdigit() == True:
		return int(val)
	return val