__author__="bjschuma"
__date__ ="$May 13, 2010 10:37:20 AM$"


__all__ = ["box", "button", "image", "importnode",
						"label", "menu", "node", "window"]


from ct.call import write
global parts
parts = dict()


def make(child):
	global parts
	name = str(child.nodeName).lower()
	if (name in parts.keys()) == False:
		return None
	node = parts[name](child)
	if name == "import":
		return node.part
	return node


from gtknodes.box import *
parts["vbox"] = VBox
parts["hbox"] = HBox


from gtknodes.button import *
parts["button"] = Button
parts["volume"] = VolumeButton


from gtknodes.image import *
parts["image"] = Image


from gtknodes.importnode import *
parts["import"] = Import


from gtknodes.label import *
parts["label"] = Label


from gtknodes.menu import *
parts["menubar"] = bar.MenuBar
parts["menuitem"] = item.MenuItem
parts["menuchangetheme"] = theme.MenuChangeTheme
parts["menureloadtheme"] = theme.MenuReloadTheme
parts["menuselectsong"] = playback.MenuSelectSong


from gtknodes.window import *
parts["window"] = Window
parts["scrollwindow"] = ScrolledWindow
