#! /usr/bin/python

__author__="bjschuma"
__date__ ="$May 16, 2010 7:24:02 PM$"

import gui
from ocarina import vars
from gtknodes.menu import MenuNode


class MenuReloadTheme(MenuNode):
	def __init__(self,elm):
		MenuNode.__init__(self, elm, "Reload Theme")


	def onactivate(self,menu):
		gui.build()


		
class MenuChangeTheme(MenuNode):
	def __init__(self,elm):
		MenuNode.__init__(self, elm, "Change Theme")


	def onactivate(self,menu):
		from gtkextras import dialog
		file = dialog.FileChooser("Select a theme file",vars.THEME).choose()
		if file != None:
			vars.THEME = file
			gui.build()

